# Textové pole a tlačítko
#
# Pro jednoduchost neuvažujeme text prvků.

class Entry:
    def __init__(self):
        self.x = 0
        self.y = 0
        self.change_handler = None
        
    def get_x(self):
        return self.x
    
    def set_x(self, x):
        self.x = x
        return self
    
    def get_y(self):
        return self.y
    
    def set_y(self, y):     
        self.y = y
        return self

    def get_change_handler(self):
        return self.change_handler
    
    def set_change_handler(self, change_handler):     
        self.change_handler = change_handler
        return self
    
class Button:
    def __init__(self):
        self.x = 0
        self.y = 0
        self.click_hander = None
        
    def get_x(self):
        return self.x
    
    def set_x(self, x):
        self.x = x
        return self
    
    def get_y(self):
        return self.y
    
    def set_y(self, y):     
        self.y = y
        return self

    def get_click_hander(self):
        return self.click_hander
    
    def set_click_hander(self, click_hander):     
        self.click_hander = click_hander
        return self


# Obě třídy definují atributy x, y
# a vlastnosti x, y.
#
# Například:
"""
>>> entry = Entry()
>>> entry.set_x(5)
<__main__.Entry object at 0x10b24ba10>
>>> entry.get_x()
5
>>> button = Button()
>>> button.set_x(5)
<__main__.Button object at 0x10ee116d0>
>>> button.get_x()
5
"""

# Liší se v tom, že textové pole má atribut a vlastnost change_handler
# a tlačítko click_handler.

def test_handler(widget):
    print("Handler called")
    
"""
>>> entry = Entry()
>>> entry.set_change_handler(test_handler)
<__main__.Entry object at 0x10b24ba10>
>>> entry.get_change_handler()
<function test_handler at 0x10b37e520>
>>> button = Button()
>>> button.set_click_hander(test_handler)
<__main__.Button object at 0x10ee116d0>
>>> button.get_click_hander()
<function test_handler at 0x100d3a520>
"""
