# Textové pole a tlačítko a jejich přímý předek
#
# Pro jednoduchost neuvažujeme text prvků.

class AtomicWidget:
    def __init__(self):
        self.x = 0
        self.y = 0
        
    def get_x(self):
        return self.x
    
    def set_x(self, x):
        self.x = x
        return self
    
    def get_y(self):
        return self.y
    
    def set_y(self, y):     
        self.y = y
        return self

class Entry(AtomicWidget):
    def __init__(self):
        super().__init__()
        self.change_handler = None

    def get_change_handler(self):
        return self.change_handler
    
    def set_change_handler(self, change_handler):     
        self.change_handler = change_handler
        return self
    
class Button(AtomicWidget):
    def __init__(self):
        super().__init__()
        self.click_hander = None
        

    def get_click_hander(self):
        return self.click_hander
    
    def set_click_hander(self, click_hander):     
        self.click_hander = click_hander
        return self


# Třídy Entry a Button zdědí
# atributy a vlastnosti x,y z třídy AtomicWidget.
#
# Například:
"""
>>> entry = Entry()
>>> entry.set_x(5)
<__main__.Entry object at 0x10b24ba10>
>>> entry.get_x()
5
>>> button = Button()
>>> button.set_x(5)
<__main__.Button object at 0x10ee116d0>
>>> button.get_x()
5
"""

# Vestavěný predikát isinstance rozhoduje,
# zda je objekt instancí zadané třídy.
"""
>>> isinstance(entry, AtomicWidget)
True
>>> isinstance(button, AtomicWidget)
True
>>> isinstance(button, Entry)
False
"""
