# Skupina tlačítek (bez inicializační metody)

class Button:
    pass

class Group:
    def __init__(self):
        self.items = []

    def get_items(self):
        return self.items[:]

    def set_items(self, items):
        self.items = items[:] 
        return self

class ButtonGroup(Group):
    def set_items(self, items):
        for item in items:
            if not isinstance(item, Button):
                raise TypeError("item is not a button")
        super().set_items(items) # Zavolání přepsané metody
        return self        
    

"""
>>> button1 = Button()
>>> button2 = Button()
>>> button_group = ButtonGroup()
>>> button_group.set_items([button1, button2])
<__main__.ButtonGroup object at 0x10b147fd0>
>>> button_group.get_items()
[<__main__.Button object at 0x10b0895d0>, <__main__.Button object at 0x10b147f10>]
"""

