# Zjednodušení obsluhy
#
# Obsluhu kliknutí na tlačítko a změnu textového pole můžeme
# provést v rámci obsluhy zaslání určité zprávy. 

class AtomicWidget:
    def __init__(self):
        self.x = 0
        self.y = 0
        
    def get_x(self):
        return self.x
    
    def set_x(self, x):
        self.x = x
        return self
    
    def get_y(self):
        return self.y
    
    def set_y(self, y):     
        self.y = y
        return self

class Entry(AtomicWidget):
    def entry_change(self):
        return self
    
class Button(AtomicWidget):
    def button_clicked(self):
        return self

# Uživatelský kód:
class MyButton(Button):
    def button_clicked(self):
        super().button_clicked()
        print("Kliknuto na tlačítko")
        return self

class MyEntry(Entry):
    def entry_change(self):
        super().entry_change()
        print("Obsah pole se změnil")
        return self

"""
>>> button = MyButton()
>>> button.button_clicked()
Kliknuto na tlačítko
>>> entry = MyEntry()
>>> entry.entry_change()
Obsah pole se změnil
"""
